function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; subClass.__proto__ = superClass; }

import PropTypes from 'prop-types';
import React from 'react';
import { Popper } from '@react-bootstrap/react-popper';
import DropdownContext from './DropdownContext';
import RootCloseWrapper from './RootCloseWrapper';
import mapContextToProps from 'react-context-toolbox/lib/mapContextToProps';

var DropdownMenu =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(DropdownMenu, _React$Component);

  function DropdownMenu() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _this.state = {
      toggleId: null
    };
    _this.hasInitialized = false;

    _this.handleClose = function (e) {
      if (!_this.props.onToggle) return;

      _this.props.onToggle(false, e);
    };

    return _this;
  }

  var _proto = DropdownMenu.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        show = _this$props.show,
        flip = _this$props.flip,
        menuRef = _this$props.menuRef,
        alignRight = _this$props.alignRight,
        drop = _this$props.drop,
        toggleNode = _this$props.toggleNode,
        rootCloseEvent = _this$props.rootCloseEvent,
        _this$props$popperCon = _this$props.popperConfig,
        popperConfig = _this$props$popperCon === void 0 ? {} : _this$props$popperCon;
    var placement = alignRight ? 'bottom-end' : 'bottom-start';
    if (drop === 'up') placement = alignRight ? 'top-end' : 'top-start';
    if (drop === 'right') placement = 'right-start';
    if (drop === 'left') placement = 'left-start';
    if (show && !this.hasInitialized) this.hasInitialized = show;

    var modifiers = _extends({
      flip: {
        enabled: !!flip
      }
    }, popperConfig.modifiers); // Add it this way, so it doesn't override someones usage
    // with react-poppers <Reference>


    if (toggleNode) {
      popperConfig.referenceElement = toggleNode;
    }

    return React.createElement(RootCloseWrapper, {
      disabled: !show,
      event: rootCloseEvent,
      onRootClose: this.handleClose
    }, React.createElement(Popper, _extends({}, popperConfig, {
      innerRef: menuRef,
      placement: placement,
      modifiers: modifiers,
      init: this.hasInitialized
    }), function (_ref) {
      var ref = _ref.ref,
          popper = _objectWithoutProperties(_ref, ["ref"]);

      _this2.scheduleUpdate = popper.scheduleUpdate;
      return _this2.props.children({
        ref: ref,
        show: show,
        popper: popper,
        alignRight: alignRight,
        onClose: _this2.handleClose,
        props: {
          'aria-labelledby': toggleNode && toggleNode.id
        }
      });
    }));
  };

  return DropdownMenu;
}(React.Component);

DropdownMenu.displayName = 'ReactOverlaysDropdownMenu';
DropdownMenu.propTypes = {
  /**
   * Controls the visible state of the menu, generally this is
   * provided by the parent `Dropdown` component,
   * but may also be specified as a prop directly.
   */
  show: PropTypes.bool,

  /**
   * Aligns the dropdown menu to the 'end' of it's placement position.
   * Generally this is provided by the parent `Dropdown` component,
   * but may also be specified as a prop directly.
   */
  alignRight: PropTypes.bool,

  /**
   * Enables the Popper.js `flip` modifier, allowing the Dropdown to
   * automatically adjust it's placement in case of overlap with the viewport or toggle.
   * Refer to the [flip docs](https://popper.js.org/popper-documentation.html#modifiers..flip.enabled) for more info
   */
  flip: PropTypes.bool,

  /**
   * A set of popper options and props passed directly to react-popper's Popper component.
   */
  popperConfig: PropTypes.object,

  /**
   * Override the default event used by RootCloseWrapper.
   */
  rootCloseEvent: PropTypes.string,

  /** @private */
  onToggle: PropTypes.func,

  /** @private */
  menuRef: PropTypes.func,

  /** @private */
  drop: PropTypes.string,

  /** @private */
  toggleNode: PropTypes.any
};
var DecoratedDropdownMenu = mapContextToProps(DropdownContext, function (_ref2, props) {
  var show = _ref2.show,
      alignRight = _ref2.alignRight,
      onToggle = _ref2.onToggle,
      drop = _ref2.drop,
      menuRef = _ref2.menuRef,
      toggleNode = _ref2.toggleNode;
  return {
    drop: drop,
    menuRef: menuRef,
    onToggle: onToggle,
    toggleNode: toggleNode,
    show: show == null ? props.show : show,
    alignRight: alignRight == null ? props.alignRight : alignRight
  };
}, DropdownMenu);
export default DecoratedDropdownMenu;